!==================================================================================
!   Win Api
!  , ., 2022 .
!==================================================================================

                     MEMBER

   INCLUDE('FsWinApiExt.INC')
   INCLUDE('WINEQU.INC')

   MAP
     INCLUDE('BUILTINS.CLW'),ONCE   ! RTL
     INCLUDE('CWUTIL.INC'),ONCE
 
     MODULE('WINAPI')
       fsWAE_FreeLibrary(ULONG hModule),BYTE,PASCAL,RAW,NAME('FreeLibrary'),PROC
       fsWAE_GetProcAddress(ULONG hModule,*CSTRING pszProcName),LONG,PASCAL,RAW,NAME('GetProcAddress')
       fsWAE_LoadLibrary(*CSTRING pszModuleFileName),ULONG,PASCAL,RAW,NAME('LoadLibraryA')
       fsWAE_MultiByteToWideChar(Unsigned Codepage,Ulong dwFlags,ULong LpMultuByteStr, Long cbMultiByte, ULong LpWideCharStr,Long cchWideChar),RAW,PROC,Ulong,PASCAL,NAME('MultiByteToWideChar')
       fsWAE_WideCharToMultiByte(Unsigned Codepage,Ulong dwFlags,ULong LpWideCharStr,Long cchWideChar, ULong lpMultuByteStr, Long cbMultiByte, Ulong LpDefalutChar,Ulong lpUsedDefalutChar),Raw,PROC,Ulong,Pascal,NAME('WideCharToMultiByte')

       fsWAE_OutputDebugString(*CString),RAW,PASCAL,NAME('OutputDebugStringA')
       fsWAE_GetEnvironmentVar(*CSTRING,*CSTRING,UNSIGNED),UNSIGNED,PASCAL,RAW,NAME('GetEnvironmentVariableA')
     END

     module('CWRTL')
       memcpy(LONG destination, LONG source, LONG bytes), LONG, NAME('_memcpy'),PROC
     end    

     MODULE('kernel32.dll')
       fsWAE_GetDiskFreeSpace(<*CSTRING lpDirectoryName>,LONG lpFreeBytesAvailableToCaller=0,LONG lpTotalNumberOfBytes=0,LONG lpTotalNumberOfFreeBytes=0),BOOL,PASCAL,RAW,DLL(_GetDiskFreeSpaceExA_),name('GetDiskFreeSpaceExA')  
     END
 
     MODULE('wtsapi32.dll')
       fsWAE_WTSQuerySessionInformation(LONG hServer,ULONG SessionId,BYTE WTSInfoClass, *ULONG ppBuffer,*ULONG pBytesReturned), SIGNED, PASCAL, RAW, DLL(_WTSQuerySessionInformation_ ) , NAME('WTSQuerySessionInformationA')    
       fsWAE_WTSFreeMemory(LONG pMemory),PASCAL,DLL(_WTSFreeMemory_),RAW , NAME('WTSFreeMemory')
     END

   END

   INCLUDE('FsWinApiExt.equ')

!===================================================================================
!  
!
FsWinApiExt.Init PROCEDURE  (BYTE pLib)
loc:NameDLL    CSTRING('kernel32.dll')
loc:NameDLLts  CSTRING('wtsapi32.dll')
      CODE

   if SELF.Active=1
      return
   end
      
   case pLib
      of 1
         SELF.HandleDLL = fsWAE_LoadLibrary(loc:NameDLL)
      of 2   
         SELF.HandleDLL = fsWAE_LoadLibrary(loc:NameDLLts)
      else
         return
   .   
   if SELF.HandleDLL=0
      return
   end 
      
   SELF.LibraryID = pLib      
            
   SELF.Active=1            
   SELF.LoadLib
   if SELF.Active=0
      if fsWAE_FreeLibrary(SELF.HandleDLL)
      end
      SELF.Active=0
      return
   end

 !===================================================================================
!  
!
FsWinApiExt.LoadLib PROCEDURE
      CODE

   ! 
   if SELF.LibraryID=1 
      loop
         _GetDiskFreeSpaceExA_ = fsWAE_GetProcAddress(SELF.HandleDLL, cstr_GetDiskFreeSpaceExA)
         if _GetDiskFreeSpaceExA_ =0
            SELF.Active=0
            break
         end
         
         break
      end     
   elsif SELF.LibraryID=2
      loop
         _WTSQuerySessionInformation_ = fsWAE_GetProcAddress(SELF.HandleDLL, cstr_WTSQuerySessionInformation)
         if _WTSQuerySessionInformation_ =0
            SELF.Active=0
            break
         end
         _WTSFreeMemory_ = fsWAE_GetProcAddress(SELF.HandleDLL, cstr_WTSFreeMemory)
         if _WTSFreeMemory_ =0
            SELF.Active=0
            break
         end         
         
         break
      end           
   end

!===================================================================================
!  
!
FsWinApiExt.Kill PROCEDURE
      CODE
      
   if SELF.Active=1  
      if fsWAE_FreeLibrary(SELF.HandleDLL)
      end        
   end     

   SELF.Active=0
  
!===================================================================================
!
!  
!
FsWinApiExt.Destruct PROCEDURE
   CODE
      if SELF.Active=1
         SELF.Kill
      end
        
!===================================================================================
!     
!
FsWinApiExt.GetDiskFreeSpace FUNCTION (STRING pDir)
loc:szDirectory                      CSTRING(32)
loc:u64_FreeBytesAvailableToCaller   LIKE(fsWAE_INT64)
loc:u64_TotalNumberOfBytes           LIKE(fsWAE_INT64)
loc:u64_TotalNumberOfFreeBytes       LIKE(fsWAE_INT64)            
loc:freeBytes                        DECIMAL(31)
loc:zn                               STRING(32)
      CODE   
      
       if SELF.Active=0 or SELF.LibraryID<>1
          return(0)
       .     
      
       loc:freeBytes=0
       loc:szDirectory = clip(pDir)        
       if fsWAE_GetDiskFreeSpace(loc:szDirectory,Address(loc:u64_FreeBytesAvailableToCaller),Address(loc:u64_TotalNumberOfBytes),Address(loc:u64_TotalNumberOfFreeBytes)) = TRUE
          loc:freeBytes = (loc:u64_FreeBytesAvailableToCaller.Hi * 4294967295) + loc:u64_FreeBytesAvailableToCaller.Lo
       end
      
       loc:zn=loc:freeBytes
       return(loc:zn)
      
!===================================================================================
!    
!
FsWinApiExt.DiskSpaceFormat FUNCTION (STRING pSize)
loc:size      long
loc:flagSize  string(2)
loc:str       string(30)
      CODE         
      
     loc:size=pSize/1024/1024/1024
     loc:flagSize=''
     if loc:size=0
        loc:size=pSize/1024/1024
        loc:flagSize=''         
     end    
     if loc:size=0
        loc:size=pSize/1024
        loc:flagSize=''         
     end       
     if loc:size=0
        loc:size=pSize
        loc:flagSize=''         
     end            
      
     loc:str=format(pSize,@P### ### ### ### ### ###P)
     loop  
        if sub(loc:str,1,3)='000'
           loc:str=left(sub(loc:str,4,len(clip(loc:str))-3)) 
           cycle
        .
        break 
     end    
      
     return(clip(left(loc:str)) & '  -  (' & loc:size & ' ' & loc:flagSize & ')' ) 
      
!===================================================================================
!       
!      
FsWinApiExt.TSGetSessionInfo   PROCEDURE(BYTE pReg) !,STRING
loc:value         string(128)
loc:BufferPtr     ULONG
loc:BufferLength  ULONG
loc:BufferRef     &CSTRING
  code
   
     if SELF.Active=0 or SELF.LibraryID<>2
        return('')
     end     
         
    if fsWAE_WTSQuerySessionInformation(fsWAE_WTS_CURRENT_SERVER_HANDLE,fsWAE_WTS_CURRENT_SESSION,pReg,loc:BufferPtr,loc:BufferLength)
      loc:BufferRef &= new(cstring(loc:BufferLength+1))
      memcpy(address(loc:BufferRef), loc:BufferPtr, loc:BufferLength)
      loc:value = loc:BufferRef
      dispose(loc:BufferRef)
      fsWAE_WTSFreeMemory(loc:BufferPtr)
    end
   
    return (loc:value)            
      
!===================================================================================
!       
!      
FsWinApiExt.TSGetClientName   PROCEDURE() !,STRING
  code
   
     if SELF.Active=0 or SELF.LibraryID<>2
        return('')
     end     
   
     return(SELF.TSGetSessionInfo(fsWAE_WTSClientName))
   
!===================================================================================
!       
!      
FsWinApiExt.TSGetClientAddress   PROCEDURE !,STRING
loc:value         string(20)
loc:BufferPtr     ULONG
loc:BufferLength  ULONG
loc:wts_client_addressRef &fsWTS_CLIENT_ADDRESS
  code
   
     if SELF.Active=0 or SELF.LibraryID<>2
        return('')
     end     
   
     loc:value=''
         
    if fsWAE_WTSQuerySessionInformation(fsWAE_WTS_CURRENT_SERVER_HANDLE,fsWAE_WTS_CURRENT_SESSION,fsWAE_WTSClientAddress,loc:BufferPtr,loc:BufferLength)
      loc:wts_client_addressRef &= (loc:BufferPtr)   
      if loc:wts_client_addressRef.AddressFamily = fsAF_INET   
         loc:value=loc:wts_client_addressRef.Address[3] & '.' & loc:wts_client_addressRef.Address[4] & '.' & loc:wts_client_addressRef.Address[5] & '.' & loc:wts_client_addressRef.Address[6]  
      end   
      fsWAE_WTSFreeMemory(loc:BufferPtr)
    end
   
    return (loc:value)              
         
      
   
   
   
      
      